/*----- PROTECTED REGION ID(PSI_PC.h) ENABLED START -----*/
//=============================================================================
//
// file :        PSI_PC.h
//
// description : Include for the PSI_PC class.
//
// project :     PSI power supplies.
//
// $Author$
//
// $Revision$
// $Date$
//
// SVN only:
// $HeadURL$
//
// CVS only:
// $Source:  $
// $Log:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef PSI_PC_H
#define PSI_PC_H


#include <tango.h>
#include <pscip.h>
#include "psc_codes.h"          //taken from Elettra - needs checking
#include "pscip_codes.h"
#include "NanoSeconds.h"

#include <vector>
#include <time.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#import <cmath>

#include <iomanip>

#define MAX_NUM_OF_DETECTED_ERRMSGS 20
#define FiberConnection                         0
#define SerialConnection                        1

/*      PSC states.
        Source: "User documentation Power Supply DSP Firmware"
*/

#define OFFSET_VALUE          0.0
#define TIME_TO_NEXT_RECON    5.0 /* seconds */
#define WVF_TOTAL             12 /* number of hardware waveforms */
#define WVF_SECTOR_MIN        4  /* first allowed sector to save waveforms */
#define WVF_SECTOR_MAX        14 /* last allowed sector to save waveforms */
#define WVF_SECTOR_RAM        19 /* RAM sector */
#define WVF_RETRY_SLEEP       200000 /* micro secs */
#define WVF_MAX_POINTS        0x3FFF /* max number of points in a waveform */
#define WVF_MAX_RETRY         10
#define WVF_BREAKPOINT        0xFFFFFFFF

#define PS_MONITOR            0 /* standby */
#define PS_DEVICE_OFF         1 /* off */
#define PS_DEVICE_ON          2 /* on */
#define PS_ADC_CAL            3 /* init */
#define PS_DEVICE_LOCKED      4
#define PS_TRANSIENT          5 /* init */
#define PS_DEVICE_OFF_LOCKED  6
#define PS_DOWNLOAD_DATA      8
#define PS_SAVE_DATA          9
#define PS_MODIFY_DATA       11

/* Psc status added flag */
#define PSC_PC_ON_STATE     16 /* on=true; off=false */
#define PSC_PC_LOCK_STATE   17 /* error=true; ok=false */
#define PSC_ALARM_SIGNAL    18 /* alarm signal from kempower */
#define PSC_FAULT_SIGNAL    19 /* alarm from PC controller */
#define PSC_CYCLERUN        20
#define PSC_CYCLEERR        21
#define PSC_STANDBYRUN      22
#define PSC_STANDBYERR      23
#define PSC_RUNWAVE         24 /* running waveform */
#define PSC_WAVEBREAK       25 /* waveform stopped on a breakpoint */
#define PSC_NOTINIT         26 /* power supply not initialized */
#define PSC_CURRENTRUN      27
#define PSC_CURRENTERR      28


/*----- PROTECTED REGION END -----*/


/**
 *	PSI_PC class Description:
 *	<pre>
 *	Control of SR power supplies.. The Device Server is meant to provide control of
 *	PSI Power Supply Controllers. The DS is basic/universal, it means that it can
 *	be used as a base for developing Device Servers for PSI PSC intended for
 *	specific usage which requires implementing additional functions (ex. upload/
 *	download waveform).
 *	
 *	The Device Server can use two types of hardware connection to communicate with
 *	PSI PSC: serial (RS232) or fiber. The connection type is determined by setting
 *	the property: ConnectionType (0 for fiber and 1 for serial).
 *	
 *	For simplicity, PSC DS connected by serial connection will be called serial DS,
 *	PSC DS connected by fiber connection will be called fiber DS.
 *	
 *	Serial connection is considered as local and 'service', it is not supposed to
 *	be used on normal basis, just in extraordinary cases.
 *	Fiber connection is considered a default connection meant to be used most of
 *	the time.
 *	
 *	Fiber connection uses PCI/cPCI Carrier Card. Each card carries two Industrial
 *	Pack (IP), each having two channels. Each channel of IP is connected to one
 *	PSC. One IP is represented in /dev/ folder as node called pscipX (X is number).
 *	If fiber connection is to be used, the property 'FODevice' needs to be set (ex
 *	'/dev/pscip0') along with 'Channel' property (0 or 1).
 *	
 *	Serial connection uses PySerial Device Server. The property 'TangoDevice' needs
 *	to be set inicating the Py Serial name and localization (ex. 'ws/pc-test/
 *	ocem00-serial ').
 *	
 *	For the PySerial to work properly, the following attributes need to be set:
 *	
 *	       _________________________________________________________________
 *	      |Attr_name|value__________________________________________________|
 *	      |Bautrate_|115200_________________________________________________|
 *	      |DataBits_|8______________________________________________________|
 *	      |Parity___|odd____________________________________________________|
 *	      |Port_____|Correct_port_to_which_PSC_is_connected_(ex._/dev/ttyR0)|
 *	      |StopBits_|1______________________________________________________|
 *	
 *	
 *	In theory, instead of PySerial DS, any DS can be used instead of PySerial
 *	without any changes to PSI SD as long as the following commands are
 *	implemented:
 *	    * 'ReadLine' for reading data,
 *	    * 'Write' for writing
 *	    * 'Open'
 *	    * 'Close'
 *	    * 'State'
 *	Both connections can be used simultaneously only for reading. When writing, a
 *	priority is given to one of the Device Servers The priority can be only set
 *	Serial DS. It means that DS connected by fiber cannot regain writing priority ,
 *	it has to be granted priority. For safety reasons the priority is granted to
 *	serial DS as long as it is connected to PSC. To be precise, the priority for
 *	serial DS is granted as soon as it attempts the first write. The priority is
 *	set to fiber DS only if serial DS is disconnected from PSC.
 *	
 *	CAUTION: If the priority is set to serial DS and an attempt to write is made by
 *	fiber DS, the fiber DS gives no error message, it looks as if the operation was
 *	successful, however, the value is not written.
 *	
 *	The following documentation is available, which can be useful for future
 *	developers/users:
 *	1) Communication_protocol.doc is adescription of communication protocol between
 *	DS and PSC
 *	2) DSP_SW_R4_User_Documentation_English.doc is a description of PSI Power
 *	Supply Controller (all registers and their meaning, meaning of leds, etc)
 *	3) Messages_Codes_en.xls explains meaning of error codes from PSC
 *	4) DS_Specification Architecture and Design of the TANGO device server for the
 *	Power supplies at ALBA
 *	Detailed documentation describing hardware used is provided with the PSCIP
 *	Linux Device Driver.
 *	Commands, attributes and properties detailed description.
 *	The following symbols are used:
 *	                 _____________________________________________
 *	                |Symbol_|meaning__________|Attribute_/property|
 *	                |I______|current__________|Attribute__________|
 *	                |I_ideal|current_setpoint_|Attribute__________|
 *	                |I_ref__|current_reference|Attribute__________|
 *	                |o______|offset___________|Attribute__________|
 *	                |f______|current_factor___|Property___________|
 *	In most of the cases the default values of 'offset' and 'current factor' should
 *	be set:
 *	o = 0
 *	f = 1
 *	Change of the default setting should be done only in the case User knows what
 *	he/she is doing !!!!
 *	Attributes:
 *	 _____________________________________________________________________________
 *	|Name____________|Description_________________________________________________|
 *	|Current         |current calculated out of measured ( by PSC ) current       |
 *	|                |according to the following formula:                         |
 *	|________________|__________I_=_I_ideal_+_(_I_ref_-_I_measured_)_/_f__________|
 *	|CurrentSetpoint |the ideal current which is intended to be acquired, it is   |
 *	|                |not the current set to the hardware, the current set in the |
 *	|                |hardware is calculated according to the following formula:  |
 *	|________________|(_I_ideal_+_o_)_____________________________________________|
 *	|CurrentOffset   |a value added to the current written to the 'current        |
 *	|________________|setpoint'_attribute_________________________________________|
 *	|CurrentReference|the_current_value_written_to_the_hardware___________________|
 *	|CurrentMeasured_|current_measurement_read_from_the_hardware__________________|
 *	|Errors          |returns readable information about all the errors which have|
 *	|                |occurred. If error occurs more then one time, it is not     |
 *	|________________|duplicated_in_the_return_table______________________________|
 *	|ErrorCodes      |returns codes of the latest errors detected according to    |
 *	|________________|categories_stored_in_ErrorLabel_attribute___________________|
 *	|ErrorLabel______|returns_the_categories_of_the_error_codes___________________|
 *	|RemoteMode      |is glued to 1 (means remote mode) because PSC can only be   |
 *	|________________|operated_remotely___________________________________________|
 *	|State___________|returns_device_state_(short_message)________________________|
 *	|Status__________|returns_human_readable,_textual_description_________________|
 *	|Voltage_________|returns_voltage_measured_on_the_load________________________|
 *	Properties:
 *	       ________________________________________________________________
 *	      |Name___________________|Description_____________________________|
 *	      |Channel                |(0 or 1) defines IP channel used to     |
 *	      |_______________________|connect_PSC_by_fiber____________________|
 *	      |ConnectionType         |(0 - fiber; 1 - serial) determines which|
 *	      |                       |hardware medium is used to connect      |
 *	      |_______________________|industrial_PC_with_PSC__________________|
 *	      |FODevice               |defines device used for fiber optic     |
 *	      |_______________________|connection_(ex._/dev/pscip0)____________|
 *	      |TangoDevice            |defines name and location of PySerial DS|
 *	      |_______________________|used_for_serial_communication___________|
 *	      |Current_factor_________|multiplier______________________________|
 *	      |InterlockFlowBit       |'flow' interlock and 'temperature'      |
 *	      |InterlockTemperatureBit|interlock signals are represented in    |
 *	      |                       |'Digital_Input_Signals' register of PSC |
 *	      |                       |as bits. The properties allow user to   |
 *	      |                       |determine which bits of the PSC register|
 *	      |                       |are associated with this interlocks. If |
 *	      |                       |correctly defined, these properties     |
 *	      |                       |enable DS to recognize Flow and         |
 *	      |                       |Temperature interlocks and provide user |
 *	      |_______________________|with_appropriate_error_message__________|
 *	
 *	Commands:
 *	 _____________________________________________________________________________
 *	|Name______________|Description_______________________________________________|
 *	|ClearError        |clear Disorder register in PSC, Error and ErrorCodes      |
 *	|__________________|attributes_in_DS__________________________________________|
 *	|Disable_interlocks|write Digital_Input_Signals_Mask with 0xE070 value. I     |
 *	|                  |causes all the interlocks, except one, to be disabled. The|
 *	|                  |not disabled interlock has input at the rear of PSC and   |
 *	|                  |can be disabled hardware-wise. The change of Mask register|
 *	|__________________|value_is_temporary._______________________________________|
 *	|Enable_interlocks |write Digital_Input_Signals_Mask with 0xF877 value.       |
 *	|__________________|Interlocks_are_enabled____________________________________|
 *	|Interlocks_state  |shows the current value of Digital_Input_Signals_Mask,    |
 *	|                  |Three states: 'Interlocks enabled', 'Interlocks disabled' |
 *	|__________________|or_'Interlocks_customized'________________________________|
 *	|Init              |default function which re-initialize Device Server not    |
 *	|__________________|affecting_the_state_of_the_hardware_______________________|
 *	|Off_______________|turns_off_the_device______________________________________|
 *	|On________________|turns_on_the_device_______________________________________|
 *	|Read_PSC_register |enable user to read any PSC register which is read-       |
 *	|                  |enabled. The address and (optionally) format of output    |
 *	|                  |data need to be specified. The default format is          |
 *	|                  |hexadecimal. Example input data '0x00' will read register |
 *	|                  |0x00 and output it data as hexadecimal, '0x00 f' will read|
 *	|__________________|register_0x00_and_output_it_as_flaot______________________|
 *	|Reset             |resets PSC by turning it off, an attempt to reestablish   |
 *	|                  |connection with hardware is taken if it has been lost. It |
 *	|__________________|also_calls_ClearErrors_command____________________________|
 *	|State             |the same as attributes                                    |
 *	|Status____________|__________________________________________________________|
 *	</pre>
 */

namespace PSI_PC_ns
{
	/*----- PROTECTED REGION ID(PSI_PC::Additional Class Declarations) ENABLED START -----*/

		//		Additional Class Declarations
    static void* _read_waveform_threaded(void* ptr);
    static void* _write_waveform_threaded(void* ptr);

	/*----- PROTECTED REGION END -----*/	//	PSI_PC::Additional Class Declarations


class PSI_PC : public Tango::Device_4Impl
{


	/*----- PROTECTED REGION ID(PSI_PC::Data Members) ENABLED START -----*/

	//		Add your own data members
public:
    Tango::DevDouble attr_CurrentSetpoint_write;
    Tango::DevDouble attr_I_write;
    short wvf_valid[WVF_TOTAL];

	/*----- PROTECTED REGION END -----*/	//	PSI_PC::Data Members


//	Device property data members
public:		//	Channel:	Channel used of PC
	Tango::DevShort	channel;
	//	FODevice:	BName of the Linux character / block device.
	string	fODevice;
	//	Interlock1:	Defines which bit of digital input register indicates temperature interlock
	string	interlock1;
	//	Interlock2:	message to be shown for external interlock 2
	string	interlock2;
	//	TangoDevice:	name of the python serial device server responisble for serial communication
	string	tangoDevice;
	//	ConnectionType:	You can choose the kind of connection the DS ``talks`` with PSC:
	//	0 -> fiber
	//	1 -> serial (RS232)
	//	
	//	To run RS232 you need to create pySerial DS
	Tango::DevShort	connectionType;
	//	CurrentFactor:	scaling factor ( f ):
	//	Iref = f * ( I_idal + o )
	Tango::DevFloat	currentFactor;
	//	Interlock3:	message to be shown for External Interlock 3
	string	interlock3;
	//	Interlock4:	message to be shown for external interlock 4
	string	interlock4;
	

//	Attribute data members
public:
	Tango::DevDouble	*attr_CurrentSetpoint_read;
	Tango::DevDouble	*attr_Voltage_read;
	Tango::DevBoolean	*attr_RemoteMode_read;
	Tango::DevDouble	*attr_Current_read;
	Tango::DevDouble	*attr_CurrentOffset_read;
	Tango::DevDouble	*attr_I_read;
	Tango::DevFloat	*attr_V_read;
	Tango::DevLong	*attr_ErrorCode_read;
	Tango::DevBoolean	*attr_WVFAutoTrigger_read;
	Tango::DevLong	*attr_WVFPartitionStart_read;
	Tango::DevBoolean	*attr_WVFRamping_read;
	Tango::DevFloat	*attr_WVFScaling_read;
	Tango::DevUShort	*attr_WVFSelected_read;
	Tango::DevULong	*attr_WVFStepSize_read;
	Tango::DevLong	*attr_WVFStoppedFlag_read;
	Tango::DevLong	*attr_DAC1Setting_read;
	Tango::DevFloat	*attr_DAC1Offset_read;
	Tango::DevFloat	*attr_DAC1Scaling_read;
	Tango::DevLong	*attr_DAC2Setting_read;
	Tango::DevFloat	*attr_DAC2Offset_read;
	Tango::DevFloat	*attr_DAC2Scaling_read;
	Tango::DevDouble	*attr_SoftwareWaveform_read;
	Tango::DevShort	*attr_ErrorCodes_read;
	Tango::DevString	*attr_ErrorLabel_read;
	Tango::DevString	*attr_Errors_read;
	Tango::DevFloat	*attr_WVF0_read;
	Tango::DevFloat	*attr_WVF1_read;
	Tango::DevFloat	*attr_WVF2_read;
	Tango::DevFloat	*attr_WVF3_read;
	Tango::DevFloat	*attr_WVF4_read;
	Tango::DevFloat	*attr_WVF5_read;
	Tango::DevFloat	*attr_WVF6_read;
	Tango::DevFloat	*attr_WVF7_read;
	Tango::DevFloat	*attr_WVF8_read;
	Tango::DevFloat	*attr_WVF9_read;
	Tango::DevFloat	*attr_WVF10_read;
	Tango::DevFloat	*attr_WVF11_read;



//	Constructors and destructors
public:
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	PSI_PC(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	PSI_PC(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly allocated Command object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	PSI_PC(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The object destructor.
	 */	
	~PSI_PC() {delete_device();};



//	Miscellaneous methods
public:
	/**
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/**
	 *	Initialize the device
	 */
	virtual void init_device();
	/**
	 *	Read the device properties from database
	 */
	 void get_device_property();
	/**
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	/**
	 *	Method      : PSI_PC::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	virtual void read_attr_hardware(vector<long> &attr_list);


	/**
	 *	CurrentSetpoint attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_CurrentSetpoint(Tango::Attribute &attr);
	virtual void write_CurrentSetpoint(Tango::WAttribute &attr);
	virtual bool is_CurrentSetpoint_allowed(Tango::AttReqType type);



	/**
	 *	Voltage attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_Voltage(Tango::Attribute &attr);
	virtual bool is_Voltage_allowed(Tango::AttReqType type);



	/**
	 *	RemoteMode attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar 
	 */
	virtual void read_RemoteMode(Tango::Attribute &attr);
	virtual bool is_RemoteMode_allowed(Tango::AttReqType type);



	/**
	 *	Current attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_Current(Tango::Attribute &attr);
	virtual bool is_Current_allowed(Tango::AttReqType type);



	/**
	 *	CurrentOffset attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_CurrentOffset(Tango::Attribute &attr);
	virtual void write_CurrentOffset(Tango::WAttribute &attr);
	virtual bool is_CurrentOffset_allowed(Tango::AttReqType type);



	/**
	 *	I attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Scalar 
	 */
	virtual void read_I(Tango::Attribute &attr);
	virtual void write_I(Tango::WAttribute &attr);
	virtual bool is_I_allowed(Tango::AttReqType type);



	/**
	 *	V attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Scalar 
	 */
	virtual void read_V(Tango::Attribute &attr);
	virtual bool is_V_allowed(Tango::AttReqType type);



	/**
	 *	ErrorCode attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar 
	 */
	virtual void read_ErrorCode(Tango::Attribute &attr);
	virtual bool is_ErrorCode_allowed(Tango::AttReqType type);



	/**
	 *	WVFAutoTrigger attribute related methods.
	 *	Description: <pre>
 *	             Wavefrom will indefinitely repeat once triggered (True) or it will run only once (False)
 *	             See WVFStart command doc for more information
 *	             </pre>
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar 
	 */
	virtual void read_WVFAutoTrigger(Tango::Attribute &attr);
	virtual void write_WVFAutoTrigger(Tango::WAttribute &attr);
	virtual bool is_WVFAutoTrigger_allowed(Tango::AttReqType type);



	/**
	 *	WVFPartitionStart attribute related methods.
	 *	Description: <pre>
 *	             Indicates the start position of the current partition.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar 
	 */
	virtual void read_WVFPartitionStart(Tango::Attribute &attr);
	virtual bool is_WVFPartitionStart_allowed(Tango::AttReqType type);



	/**
	 *	WVFRamping attribute related methods.
	 *	Description: <pre>
 *	             If true, then the end value of a waveform is taken over on encountering a new trigger signal as an offset value
 *	             </pre>
	 *
	 *	Data type:	Tango::DevBoolean
	 *	Attr type:	Scalar 
	 */
	virtual void read_WVFRamping(Tango::Attribute &attr);
	virtual void write_WVFRamping(Tango::WAttribute &attr);
	virtual bool is_WVFRamping_allowed(Tango::AttReqType type);



	/**
	 *	WVFScaling attribute related methods.
	 *	Description: <pre>
 *	             Scaling factor of the waveform: data points are multiplied by this value (default is 1.0)
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Scalar 
	 */
	virtual void read_WVFScaling(Tango::Attribute &attr);
	virtual void write_WVFScaling(Tango::WAttribute &attr);
	virtual bool is_WVFScaling_allowed(Tango::AttReqType type);



	/**
	 *	WVFSelected attribute related methods.
	 *	Description: <pre>
 *	             To select a waveform or read currently selected waveform.
 *	             
 *	             Note that number waveform 0 is RAM waveform (and hence it is volatile and gets
 *	             overwritten whenever an operation uses the temporary RAM). Waveforms 1..11 are
 *	             stored in a flash memory inside the hardware controller and hence they are non
 *	             volatile.
 *	             
 *	             NOTE that you cannot select RAM waveform: this is because the hadware will go to
 *	             alarm even if you don't immediately write WVF0 after selecting RAM waveform: in
 *	             order to select RAM waveform you have to write WVF0 with the target waveform and
 *	             then WVFSelected will automatically go to RAM.
 *	             
 *	             After hardware restart WVFSelected is invalid and hence neither Start nor Trigger
 *	             would have any effect. However WVFSelected is a memorized attribute and should
 *	             restore the last selected waveform (provided the hardware is OK).
 *	             </pre>
	 *
	 *	Data type:	Tango::DevUShort
	 *	Attr type:	Scalar 
	 */
	virtual void read_WVFSelected(Tango::Attribute &attr);
	virtual void write_WVFSelected(Tango::WAttribute &attr);
	virtual bool is_WVFSelected_allowed(Tango::AttReqType type);



	/**
	 *	WVFStepSize attribute related methods.
	 *	Description: <pre>
 *	             Time betweeen points in the waveform (default is 80 micro secs)
 *	             
 *	             NOTE. If you write when a waveform is active the waveform is restarted and
 *	             the change is applied. However it looks like there is some kind of bug in
 *	             the hardware: if you increase step size then it seems to work fine, but if
 *	             you decrease it then it does not.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevULong
	 *	Attr type:	Scalar 
	 */
	virtual void read_WVFStepSize(Tango::Attribute &attr);
	virtual void write_WVFStepSize(Tango::WAttribute &attr);
	virtual bool is_WVFStepSize_allowed(Tango::AttReqType type);



	/**
	 *	WVFStoppedFlag attribute related methods.
	 *	Description: <pre>
 *	             Read: Indicates when an existing stop flag is reached within a waveform. 
 *	             
 *	             Write 1:  Jumps to the next partition in the waveform.
 *	             Write 0: Jumps back to the start of the waveform.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar 
	 */
	virtual void read_WVFStoppedFlag(Tango::Attribute &attr);
	virtual void write_WVFStoppedFlag(Tango::WAttribute &attr);
	virtual bool is_WVFStoppedFlag_allowed(Tango::AttReqType type);



	/**
	 *	DAC1Setting attribute related methods.
	 *	Description: <pre>
 *	             Address of displayed signal on DAC1
 *	             </pre>
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar 
	 */
	virtual void read_DAC1Setting(Tango::Attribute &attr);
	virtual void write_DAC1Setting(Tango::WAttribute &attr);
	virtual bool is_DAC1Setting_allowed(Tango::AttReqType type);



	/**
	 *	DAC1Offset attribute related methods.
	 *	Description: <pre>
 *	             DAC 1 signal offset
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Scalar 
	 */
	virtual void read_DAC1Offset(Tango::Attribute &attr);
	virtual void write_DAC1Offset(Tango::WAttribute &attr);
	virtual bool is_DAC1Offset_allowed(Tango::AttReqType type);



	/**
	 *	DAC1Scaling attribute related methods.
	 *	Description: <pre>
 *	             DAC 1 scaling factor (1/V)
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Scalar 
	 */
	virtual void read_DAC1Scaling(Tango::Attribute &attr);
	virtual void write_DAC1Scaling(Tango::WAttribute &attr);
	virtual bool is_DAC1Scaling_allowed(Tango::AttReqType type);



	/**
	 *	DAC2Setting attribute related methods.
	 *	Description: <pre>
 *	             Address of displayed signal on DAC2
 *	             </pre>
	 *
	 *	Data type:	Tango::DevLong
	 *	Attr type:	Scalar 
	 */
	virtual void read_DAC2Setting(Tango::Attribute &attr);
	virtual void write_DAC2Setting(Tango::WAttribute &attr);
	virtual bool is_DAC2Setting_allowed(Tango::AttReqType type);



	/**
	 *	DAC2Offset attribute related methods.
	 *	Description: <pre>
 *	             DAC 2 signal offset
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Scalar 
	 */
	virtual void read_DAC2Offset(Tango::Attribute &attr);
	virtual void write_DAC2Offset(Tango::WAttribute &attr);
	virtual bool is_DAC2Offset_allowed(Tango::AttReqType type);



	/**
	 *	DAC2Scaling attribute related methods.
	 *	Description: <pre>
 *	             DAC 2 scaling factor (1/V)
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Scalar 
	 */
	virtual void read_DAC2Scaling(Tango::Attribute &attr);
	virtual void write_DAC2Scaling(Tango::WAttribute &attr);
	virtual bool is_DAC2Scaling_allowed(Tango::AttReqType type);



	/**
	 *	SoftwareWaveform attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevDouble
	 *	Attr type:	Spectrum  max = 1000000
	 */
	virtual void read_SoftwareWaveform(Tango::Attribute &attr);
	virtual void write_SoftwareWaveform(Tango::WAttribute &attr);
	virtual bool is_SoftwareWaveform_allowed(Tango::AttReqType type);



	/**
	 *	ErrorCodes attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevShort
	 *	Attr type:	Spectrum  max = 5
	 */
	virtual void read_ErrorCodes(Tango::Attribute &attr);
	virtual bool is_ErrorCodes_allowed(Tango::AttReqType type);



	/**
	 *	ErrorLabel attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevString
	 *	Attr type:	Spectrum  max = 5
	 */
	virtual void read_ErrorLabel(Tango::Attribute &attr);
	virtual bool is_ErrorLabel_allowed(Tango::AttReqType type);



	/**
	 *	Errors attribute related methods.
	 *	Description: 
	 *
	 *	Data type:	Tango::DevString
	 *	Attr type:	Spectrum  max = 20
	 */
	virtual void read_Errors(Tango::Attribute &attr);
	virtual bool is_Errors_allowed(Tango::AttReqType type);



	/**
	 *	WVF0 attribute related methods.
	 *	Description: <pre>
 *	             Waveform stored in temporary RAM.
 *	             
 *	             NOTE that any operation that uses temporary RAM will overwrite this waveform!
 *	             This will happen for example when you start a waveform different than the RAM
 *	             one. The hardware also considers that RAM waveform is invalid after reading or
 *	             writing any other waveform or even simply writing WVFSelected attribute. I
 *	             checked that actually the RAM waveform only gets actually overwriten when a
 *	             different waveform is started, but since the hardware reports ALARM state and
 *	             ``data not copied`` disorder then we follow the hardware rules.
 *	             
 *	             NOTE that prior writing RAM waveform we will set WVFSelected to RAM (see
 *	             WVFSelected documentation to find out why). We do not do that for waveforms
 *	             stored in flash memory.
 *	             
 *	             REMEMBER that FLASH memories have a limited number of write cycles, so do not
 *	             write them unless necessary. We recommend to test your new waveforms by
 *	             writting them to RAM (WVF0) and then, once you`re happy, write them to any
 *	             other free sector.
 *	             
 *	             PARTITIONS can be set inside a waveform. Datapoints with a NaN value are
 *	             interpreted as stop flags, hence allowing segmentation of a waveform into
 *	             several partitions.  When such a stop flag is reached, the waveform is stopped.
 *	             The next partition can be switched to with a corresponding write on the
 *	             WVFStoppedFlag attribute. Take into account that 2 consecutive NaN values are
 *	             considered as a partition.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Spectrum  max = 16383
	 */
	virtual void read_WVF0(Tango::Attribute &attr);
	virtual void write_WVF0(Tango::WAttribute &attr);
	virtual bool is_WVF0_allowed(Tango::AttReqType type);



	/**
	 *	WVF1 attribute related methods.
	 *	Description: <pre>
 *	             Waveform 1 stored in flash memory.
 *	             
 *	             REMEMBER that FLASH memories have a limited number of write cycles, so do not
 *	             write them unless necessary. We recommend to test your new waveforms by
 *	             writting them to RAM (WVF0) and then, once you`re happy, write them to any
 *	             other free sector.
 *	             
 *	             PARTITIONS can be set inside a waveform. Datapoints with a NaN value are
 *	             interpreted as stop flags, hence allowing segmentation of a waveform into
 *	             several partitions.  When such a stop flag is reached, the waveform is stopped.
 *	             The next partition can be switched to with a corresponding write on the
 *	             WVFStoppedFlag attribute. Take into account that 2 consecutive NaN values are
 *	             considered as a partition.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Spectrum  max = 16383
	 */
	virtual void read_WVF1(Tango::Attribute &attr);
	virtual void write_WVF1(Tango::WAttribute &attr);
	virtual bool is_WVF1_allowed(Tango::AttReqType type);



	/**
	 *	WVF2 attribute related methods.
	 *	Description: <pre>
 *	             Waveform 2 stored in flash memory.
 *	             
 *	             REMEMBER that FLASH memories have a limited number of write cycles, so do not
 *	             write them unless necessary. We recommend to test your new waveforms by
 *	             writting them to RAM (WVF0) and then, once you`re happy, write them to any
 *	             other free sector.
 *	             
 *	             PARTITIONS can be set inside a waveform. Datapoints with a NaN value are
 *	             interpreted as stop flags, hence allowing segmentation of a waveform into
 *	             several partitions.  When such a stop flag is reached, the waveform is stopped.
 *	             The next partition can be switched to with a corresponding write on the
 *	             WVFStoppedFlag attribute. Take into account that 2 consecutive NaN values are
 *	             considered as a partition.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Spectrum  max = 16383
	 */
	virtual void read_WVF2(Tango::Attribute &attr);
	virtual void write_WVF2(Tango::WAttribute &attr);
	virtual bool is_WVF2_allowed(Tango::AttReqType type);



	/**
	 *	WVF3 attribute related methods.
	 *	Description: <pre>
 *	             Waveform 3 stored in flash memory.
 *	             
 *	             REMEMBER that FLASH memories have a limited number of write cycles, so do not
 *	             write them unless necessary. We recommend to test your new waveforms by
 *	             writting them to RAM (WVF0) and then, once you`re happy, write them to any
 *	             other free sector.
 *	             
 *	             PARTITIONS can be set inside a waveform. Datapoints with a NaN value are
 *	             interpreted as stop flags, hence allowing segmentation of a waveform into
 *	             several partitions.  When such a stop flag is reached, the waveform is stopped.
 *	             The next partition can be switched to with a corresponding write on the
 *	             WVFStoppedFlag attribute. Take into account that 2 consecutive NaN values are
 *	             considered as a partition.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Spectrum  max = 16383
	 */
	virtual void read_WVF3(Tango::Attribute &attr);
	virtual void write_WVF3(Tango::WAttribute &attr);
	virtual bool is_WVF3_allowed(Tango::AttReqType type);



	/**
	 *	WVF4 attribute related methods.
	 *	Description: <pre>
 *	             Waveform 4 stored in flash memory.
 *	             
 *	             REMEMBER that FLASH memories have a limited number of write cycles, so do not
 *	             write them unless necessary. We recommend to test your new waveforms by
 *	             writting them to RAM (WVF0) and then, once you`re happy, write them to any
 *	             other free sector.
 *	             
 *	             PARTITIONS can be set inside a waveform. Datapoints with a NaN value are
 *	             interpreted as stop flags, hence allowing segmentation of a waveform into
 *	             several partitions.  When such a stop flag is reached, the waveform is stopped.
 *	             The next partition can be switched to with a corresponding write on the
 *	             WVFStoppedFlag attribute. Take into account that 2 consecutive NaN values are
 *	             considered as a partition.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Spectrum  max = 16383
	 */
	virtual void read_WVF4(Tango::Attribute &attr);
	virtual void write_WVF4(Tango::WAttribute &attr);
	virtual bool is_WVF4_allowed(Tango::AttReqType type);



	/**
	 *	WVF5 attribute related methods.
	 *	Description: <pre>
 *	             Waveform 5 stored in flash memory.
 *	             
 *	             REMEMBER that FLASH memories have a limited number of write cycles, so do not
 *	             write them unless necessary. We recommend to test your new waveforms by
 *	             writting them to RAM (WVF0) and then, once you`re happy, write them to any
 *	             other free sector.
 *	             
 *	             PARTITIONS can be set inside a waveform. Datapoints with a NaN value are
 *	             interpreted as stop flags, hence allowing segmentation of a waveform into
 *	             several partitions.  When such a stop flag is reached, the waveform is stopped.
 *	             The next partition can be switched to with a corresponding write on the
 *	             WVFStoppedFlag attribute. Take into account that 2 consecutive NaN values are
 *	             considered as a partition.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Spectrum  max = 16383
	 */
	virtual void read_WVF5(Tango::Attribute &attr);
	virtual void write_WVF5(Tango::WAttribute &attr);
	virtual bool is_WVF5_allowed(Tango::AttReqType type);



	/**
	 *	WVF6 attribute related methods.
	 *	Description: <pre>
 *	             Waveform 6 stored in flash memory.
 *	             
 *	             REMEMBER that FLASH memories have a limited number of write cycles, so do not
 *	             write them unless necessary. We recommend to test your new waveforms by
 *	             writting them to RAM (WVF0) and then, once you`re happy, write them to any
 *	             other free sector.
 *	             
 *	             PARTITIONS can be set inside a waveform. Datapoints with a NaN value are
 *	             interpreted as stop flags, hence allowing segmentation of a waveform into
 *	             several partitions.  When such a stop flag is reached, the waveform is stopped.
 *	             The next partition can be switched to with a corresponding write on the
 *	             WVFStoppedFlag attribute. Take into account that 2 consecutive NaN values are
 *	             considered as a partition.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Spectrum  max = 16383
	 */
	virtual void read_WVF6(Tango::Attribute &attr);
	virtual void write_WVF6(Tango::WAttribute &attr);
	virtual bool is_WVF6_allowed(Tango::AttReqType type);



	/**
	 *	WVF7 attribute related methods.
	 *	Description: <pre>
 *	             Waveform 7 stored in flash memory.
 *	             
 *	             REMEMBER that FLASH memories have a limited number of write cycles, so do not
 *	             write them unless necessary. We recommend to test your new waveforms by
 *	             writting them to RAM (WVF0) and then, once you`re happy, write them to any
 *	             other free sector.
 *	             
 *	             PARTITIONS can be set inside a waveform. Datapoints with a NaN value are
 *	             interpreted as stop flags, hence allowing segmentation of a waveform into
 *	             several partitions.  When such a stop flag is reached, the waveform is stopped.
 *	             The next partition can be switched to with a corresponding write on the
 *	             WVFStoppedFlag attribute. Take into account that 2 consecutive NaN values are
 *	             considered as a partition.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Spectrum  max = 16383
	 */
	virtual void read_WVF7(Tango::Attribute &attr);
	virtual void write_WVF7(Tango::WAttribute &attr);
	virtual bool is_WVF7_allowed(Tango::AttReqType type);



	/**
	 *	WVF8 attribute related methods.
	 *	Description: <pre>
 *	             Waveform 8 stored in flash memory.
 *	             
 *	             REMEMBER that FLASH memories have a limited number of write cycles, so do not
 *	             write them unless necessary. We recommend to test your new waveforms by
 *	             writting them to RAM (WVF0) and then, once you`re happy, write them to any
 *	             other free sector.
 *	             
 *	             PARTITIONS can be set inside a waveform. Datapoints with a NaN value are
 *	             interpreted as stop flags, hence allowing segmentation of a waveform into
 *	             several partitions.  When such a stop flag is reached, the waveform is stopped.
 *	             The next partition can be switched to with a corresponding write on the
 *	             WVFStoppedFlag attribute. Take into account that 2 consecutive NaN values are
 *	             considered as a partition.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Spectrum  max = 16383
	 */
	virtual void read_WVF8(Tango::Attribute &attr);
	virtual void write_WVF8(Tango::WAttribute &attr);
	virtual bool is_WVF8_allowed(Tango::AttReqType type);



	/**
	 *	WVF9 attribute related methods.
	 *	Description: <pre>
 *	             Waveform 9 stored in flash memory.
 *	             
 *	             REMEMBER that FLASH memories have a limited number of write cycles, so do not
 *	             write them unless necessary. We recommend to test your new waveforms by
 *	             writting them to RAM (WVF0) and then, once you`re happy, write them to any
 *	             other free sector.
 *	             
 *	             PARTITIONS can be set inside a waveform. Datapoints with a NaN value are
 *	             interpreted as stop flags, hence allowing segmentation of a waveform into
 *	             several partitions.  When such a stop flag is reached, the waveform is stopped.
 *	             The next partition can be switched to with a corresponding write on the
 *	             WVFStoppedFlag attribute. Take into account that 2 consecutive NaN values are
 *	             considered as a partition.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Spectrum  max = 16383
	 */
	virtual void read_WVF9(Tango::Attribute &attr);
	virtual void write_WVF9(Tango::WAttribute &attr);
	virtual bool is_WVF9_allowed(Tango::AttReqType type);



	/**
	 *	WVF10 attribute related methods.
	 *	Description: <pre>
 *	             Waveform 10 stored in flash memory.
 *	             
 *	             REMEMBER that FLASH memories have a limited number of write cycles, so do not
 *	             write them unless necessary. We recommend to test your new waveforms by
 *	             writting them to RAM (WVF0) and then, once you`re happy, write them to any
 *	             other free sector.
 *	             
 *	             PARTITIONS can be set inside a waveform. Datapoints with a NaN value are
 *	             interpreted as stop flags, hence allowing segmentation of a waveform into
 *	             several partitions.  When such a stop flag is reached, the waveform is stopped.
 *	             The next partition can be switched to with a corresponding write on the
 *	             WVFStoppedFlag attribute. Take into account that 2 consecutive NaN values are
 *	             considered as a partition.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Spectrum  max = 16383
	 */
	virtual void read_WVF10(Tango::Attribute &attr);
	virtual void write_WVF10(Tango::WAttribute &attr);
	virtual bool is_WVF10_allowed(Tango::AttReqType type);



	/**
	 *	WVF11 attribute related methods.
	 *	Description: <pre>
 *	             Waveform 11 stored in flash memory.
 *	             
 *	             REMEMBER that FLASH memories have a limited number of write cycles, so do not
 *	             write them unless necessary. We recommend to test your new waveforms by
 *	             writting them to RAM (WVF0) and then, once you`re happy, write them to any
 *	             other free sector.
 *	             
 *	             PARTITIONS can be set inside a waveform. Datapoints with a NaN value are
 *	             interpreted as stop flags, hence allowing segmentation of a waveform into
 *	             several partitions.  When such a stop flag is reached, the waveform is stopped.
 *	             The next partition can be switched to with a corresponding write on the
 *	             WVFStoppedFlag attribute. Take into account that 2 consecutive NaN values are
 *	             considered as a partition.
 *	             </pre>
	 *
	 *	Data type:	Tango::DevFloat
	 *	Attr type:	Spectrum  max = 16383
	 */
	virtual void read_WVF11(Tango::Attribute &attr);
	virtual void write_WVF11(Tango::WAttribute &attr);
	virtual bool is_WVF11_allowed(Tango::AttReqType type);



	/**
	 *	Method      : PSI_PC::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
		void add_dynamic_attributes();

//	Command related methods
public: 
	/**
	 *	Command State related methods.
	 */
	Tango::DevState dev_state();

	/**
	 *	Command Status related methods.
	 */
	Tango::ConstDevString dev_status();

	/**
	 *	Command On related methods.
	 */
	void on();
	virtual bool is_On_allowed(const CORBA::Any &any);

	/**
	 *	Command Off related methods.
	 */
	void off();
	virtual bool is_Off_allowed(const CORBA::Any &any);

	/**
	 *	Command Reset related methods.
	 */
	void reset();
	virtual bool is_Reset_allowed(const CORBA::Any &any);

	/**
	 *	Command ResetInterlocks related methods.
	 */
	void reset_interlocks();
	virtual bool is_ResetInterlocks_allowed(const CORBA::Any &any);

	/**
	 *	Command DisableInterlocks related methods.
	 */
	void disable_interlocks();
	virtual bool is_DisableInterlocks_allowed(const CORBA::Any &any);

	/**
	 *	Command EnableInterlocks related methods.
	 */
	void enable_interlocks();
	virtual bool is_EnableInterlocks_allowed(const CORBA::Any &any);

	/**
	 *	Command InterlockStatus related methods.
	 */
	Tango::DevString interlock_status();
	virtual bool is_InterlockStatus_allowed(const CORBA::Any &any);

	/**
	 *	Command Read_PSC_register related methods.
	 */
	Tango::DevString read__psc_register(Tango::DevString argin);
	virtual bool is_Read_PSC_register_allowed(const CORBA::Any &any);

	/**
	 *	Command StopSoftwareWaveform related methods.
	 */
	void stop_software_waveform();
	virtual bool is_StopSoftwareWaveform_allowed(const CORBA::Any &any);

	/**
	 *	Command StartSoftwareWaveform related methods.
	 */
	void start_software_waveform();
	virtual bool is_StartSoftwareWaveform_allowed(const CORBA::Any &any);

	/**
	 *	Command Connect related methods.
	 */
	void connect();
	virtual bool is_Connect_allowed(const CORBA::Any &any);

	/**
	 *	Command Update related methods.
	 */
	void update();
	virtual bool is_Update_allowed(const CORBA::Any &any);

	/**
	 *	Command WVFStart related methods.
	 */
	void wvfstart(Tango::DevBoolean argin);
	virtual bool is_WVFStart_allowed(const CORBA::Any &any);

	/**
	 *	Command WVFStop related methods.
	 */
	void wvfstop(Tango::DevBoolean argin);
	virtual bool is_WVFStop_allowed(const CORBA::Any &any);

	/**
	 *	Command WVFTrigger related methods.
	 */
	void wvftrigger();
	virtual bool is_WVFTrigger_allowed(const CORBA::Any &any);



	/*----- PROTECTED REGION ID(PSI_PC::Additional Method prototypes) ENABLED START -----*/

	//	Additional Method prototypes
protected :

        /* Variables*/
        char psc_err_msg_buf[256];
        std::string status_string;      // message returned when status is called
        int fd;                                                                                                                         /**< File descriptor. */
        int numo_ErrorMsgs;                                                                              /** Number of error message in attr_ErrorMsgs_read */
        short ErrorsValue[PSC_DS_ALBA_ERRMSG];                                                          /**< Array holding values of errors. By default 0 means OK*/
        char psc_errmsg[256][PSCIP_SIZE_MSG];                                                           /**< PSCIP_SIZE_MSG defined in pscip.h */
        time_t last_comm_error;
        Tango::DeviceProxy *device;                                                                                     /**<  Proxy Used for serial communication  */

        std::vector<Tango::DevDouble> m_softwareWaveform;
        omni_thread* m_softwareWaveformThread;
        bool m_softwareWaveformThreadRunning;

        omni_thread* wvfUpDownloadThread;
        bool hwWvfStarted;
        int wvf_idx;
        std::vector<Tango::DevFloat> waveforms[WVF_TOTAL];
        void read_WVF(int idx, Tango::Attribute &attr);
   	    void write_WVF(int idx, Tango::WAttribute &attr);
        friend void* _read_waveform_threaded(void* ptr);
        friend void* _write_waveform_threaded(void* ptr);
        int read_wvfselected(void);
        void write_wvfselected(int wvf);
        int read_waveform(int idx);
        int write_waveform(int idx, float *w_val, int w_length);
        int read_and_wait(int addr, int *data, const char *msg);
        int write_and_wait(int addr, int data, const char *msg, int state=-1);

        static void* _software_waveform_thread(void* ptr);
        void do_software_waveform();

        /* Functions */
        /**  Reads value of the current which should be set by the device  */
        double readCurrentSetpointFromDevice();
        /** reads information from the hardware in order to update State and
          * Status */
        void update_state(void);
        bool psc_write(int channel, char status, char address, int data, bool wvf=false); /**< General function for writing to PSC (regardless of the communicatino medium)   */
        bool psc_read(int channel, char status, char address, int *data, bool wvf=false); /**<  General funciton for reading from PSC (regardless of the communicatio medium)  */
        void psc_read_serial(pscip_t *pval);                                                                    /**<  Reading using RS232  */
        void psc_write_serial(pscip_t *pval);                                                                   /**<  Writing using RS232  */
        void psc_read_fiber(pscip_t *pval, bool wvf=false);                                                     /**<  Reading using fiber optic  */
        void psc_write_fiber(pscip_t *pval, bool wvf=false);                                                    /**<  Writing using fiber optic  */
        void close_serial(void);                                                                                        /**<   Closing connectin to PySerial DS */
        void init_serial(void);                                                                                         /**<   Openning/initializing connection to PySerial DS */
        void init_fiber(void);                                                                                          /**<   Openning fiber device (driver) */
        void clear_errors_in_IP();                                                                                      /**<   Clearing communication errors in IP */
        void wrCurrent(Tango::WAttribute &attr, const char *);                                  /**<   Writing desired value of the current to PSC (sets currentWrite and currentSetpoint attributes */
        const char *psc_get_communication_alba_errmsg(int err);                                 /**<   returns message representing error code (from fiber driver and communication using RS232 */
        double readCurrent();
        void dev_init();                                                                                                        /**<   Initialization of the table with PSC errors (coming from power supply controller not communicatioon */
        const char * add_errmsg(const char *msg_to_add);                                                                /**<   Adding error message (regardless the  source) to the error table which is shown to the user */
        Tango::DevState  read_PySerial_state();                                                         /** < reads state of PySerial DS */
        void check_connection_to_PySerial();                                                            /** < checks the connection with PySerial, to be more precise, checks the state of PySerial and tries to reopen it if it is in OFF state, if there is an error while reading state of PySerial, it also tries reopenning PySerial, if reopening fails an exception is thrown */
        /** rethrows exception for communication failure/error changing text
            in the description of caught exception, it is used to notify the
            user that the exception comes from another device server (PySerial)
        */
        void psc_modify_and_re_throw_exception(
            Tango::DevFailed &e,            //exception to be modify
            string modify_s,                // string modifying description message
            string info_s,                  // info string
            string cmd_s,                   // cmd string
            string function_name,           // name of the function in which exception occured
            int err_code
        );

         /** rethrows exception for communication failure/error */
        void psc_re_throw_exception(
            Tango::DevFailed &e,            //exception to be modify
            string info_s,                          //info string
            string cmd_s,                           //describtion string
            string function_name,           // name of the function in which exception occured
            int err_code
        );
        void psc_throw_exception(                                                                                       /** < creates and throws exception for communication failure/error */
            string info_s,                          //info string
            string cmd_s,                           //describtion string
            string function_name,           // name of the function in which exception occured
            int err_code,
            int err_type = ERR_PSI_IP
        );
        /** checks error code of ioctls for F/O communication */
        void handle_comm_error_fiber(
            int err,
            pscip_t *val,
            const char * origin
        );

	/*----- PROTECTED REGION END -----*/	//	PSI_PC::Additional Method prototypes

};

	/*----- PROTECTED REGION ID(PSI_PC::Additional Classes Definitions) ENABLED START -----*/

	//	Additional Classes definitions

	/*----- PROTECTED REGION END -----*/	//	PSI_PC::Additional Classes Definitions

} //	namespace

#endif	//	PSI_PC_H
